#pragma once

#import "SGSVideoSource.tlb" no_namespace, named_guids

class CVideoManager
{
public:
	CVideoManager(void);
	~CVideoManager(void);

	bool InitVideoStream(SourceDlg dialog, int videoChannel);
	bool StopVideoStream();

	bool StartVideoRecord();
	bool StopVideoRecord();

	int NextFrame();
	void VideoSaveNextFrame();

	bool IsVideoStreamOpen()   { return _isVideoStreamOpen;   }
	bool IsVideoStreamRecord() { return _isVideoStreamRecord; }

	void PrepareVideoDeviceName();
	void PrepareVideoDeviceProperty();

	// Set Function
	void SetCompressoID(int id) { _compressorID = id; }

	int GetMaxVChannelNumber() { return _maxVChannelNumber;  }
	int GetVideoChannelNumber(){ return _videoChannelNumber; }

	BITMAPINFO *GetColorHeader(){ return _colorHeader; }
	BITMAPINFO *GetGrayHeader() { return _grayHeader;  }
	UCHAR *GetColorData()       { return _colorImageData; }
	UCHAR *GetGrayData()        { return _grayImageData;  }
    CString GetVideoDeviceName(){ return _videoDeviceName;}
	CString GetVideoDeviceName(int index);

	CSize GetColorImageSize(){ return CSize(_colorImageSize.width, _colorImageSize.height); }
	CSize GetGrayImageSize() { return CSize(_grayImageSize.width, _grayImageSize.height);   }

	CString *GetVideoCompressorList() { return _compressorList; }

private:
	IVideoModulePtr			_videoModulePtr;
	IVideoSaveModulePtr		_videoSaveModulePtr;
	IVideoDevicePropertyPtr _videoProrertyPtr;

	bool _isVideoStreamOpen;
	bool _isVideoStreamRecord;

	int _videoStatus;
	int _maxVChannelNumber;
    int _videoChannelNumber;
	int _compressorID;

	VideoImageSize _colorImageSize, _lastColorImageSize;
	VideoImageSize _grayImageSize;
	BITMAPINFO *_colorHeader, *_grayHeader;
	UCHAR *_colorImageData, *_grayImageData;

	CString _videoDeviceName;
	CString _videoDeviceList[MAX_DEVICE_NUM];
	CString _compressorList[MAX_COMPRESSOR_NUM];
};